"use strict";
this.name               = "combat_MFD";
this.author               = "Norby, Zireael";
this.copyright            = "2014 Norby, Zireael";
this.description         = "Makes MFDs more useful by displaying some info";
this.version            = "1.0";
this.licence     = "CC BY-NC-SA 4.0";

this.startUp = function() {
    this.$InfoTimer = new Timer(this, this.$showCombatInfo.bind(this), 1, 0.25);
    if(player.ship && player.ship.isValid)
	this.$PlayerPrevPos = player.ship.position;
    else this.$PlayerPrevPos = [0,0,0];
    this.$Target = null;
    this.$TargetPrevPos = [0,0,0];
    this.$Tws = worldScripts.telescope;
    this.$Sws = worldScripts.shieldequalizercapacitors;
}

this.shipWillLaunchFromStation = function() {
	if(this.$Sws) {
		this.$Sws.togglemessages = "OFF";
		this.$Sws.togglesoundfx2 = "OFF";
	}
	this.$showCombatInfo();
}

this.$showCombatInfo = function() {
	var p = player.ship;
	if(p && p.isValid) {
		var target = "";
		var pp = p.position;
		var sp = Math.round(0.4*pp.distanceTo(this.$PlayerPrevPos))*10;//not stable, must round to 10
		this.$PlayerPrevPos = pp;
		var t = p.target;
		if(t && t.isValid) {
			var tdn = t.displayName;//must before telescopemarker
			var tsp = "";
			var t2 = null;
			if(this.$Tws && t.dataKey=="telescopemarker") {
				t2 = this.$Tws.$TelescopeTarget;
				if(t2 && t2.isValid) t = t2;
			}
			if(this.$Target == t) { //do not show first time, need 2 pos. for speed
				tsp = Math.round(0.4*t.position.distanceTo(this.$TargetPrevPos))*10;
				if( tsp > 100000 ) tsp = Math.round( tsp / 1000 ) + " km/s";
				else tsp += " m/s";
			} else this.$Target = t; //first time save a position only
			var st = "";
			if(!t2 && (t.isShip&&t.isPiloted||t.isDerelict)) {
				st = "\nStatus: ";
				if(t.isDerelict) st += " Derelict";
				else if(t.bounty>50) st += "Fugitive";
				else if(t.bounty>0) st += "Offender";
				else st += "Clean";
			}
			var r = Math.round(t.collisionRadius);
			var d = Math.round(t.position.distanceTo(pp)-r);
			if(d > 1000000000) d = Math.round(d/1000000000)+" Mkm";
			else if(d > 30000) d = Math.round(d/1000)+" km";
			else d += " m";
			if( r > 100000 ) r = Math.round( r / 1000 ) + " km";
			else r += " m";
			target = "\n\nTarget: "+tdn+
				"\nSpeed: "+tsp+    //t.dataKey+//debug
				"\nDistance: "+d+
				"\nRadius: "+r+st;
			this.$TargetPrevPos = t.position;
		} else this.$Target = null;
		var fs = Math.round(p.forwardShield);
		if(this.$Sws) fs += Math.round(this.$Sws.secforwardshieldcapacitor);
		var as = Math.round(p.aftShield);
		if(this.$Sws) as += Math.round(this.$Sws.secaftshieldcapacitor);
		p.setMultiFunctionText("useful_MFD_combat_info",
			"Energy: "+Math.round(p.energy)+" "+
			Math.round(100*p.energy/p.maxEnergy)+
			"%\nShields: "+fs+"/"+as+
			" " +  this.$ForwardPercent(fs) + "%/" + this.$AftPercent(as) +
			"%\nFuel: " + (p.fuel).toFixed(1) +
			" ly\nSpeed: " + sp + " m/s" + target, false);
	}
}

this.$ForwardPercent = function(current)
{
  var max = player.ship.maxForwardShield;
  var result = Math.round(100*current / max);
  return result;
}

this.$AftPercent = function(current)
{
  var max = player.ship.maxAftShield;
  var result = Math.round(100*current / max);
  return result;
}